//
// GroupAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class GroupAPI: APIBase {
    /**
     add single recipient to group
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter id: (path) the id of the recipient 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func addRecipientToGroup(lid lid: String, gid: String, id: String, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        addRecipientToGroupWithRequestBuilder(lid: lid, gid: gid, id: id).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     add single recipient to group
     - POST /lists/{lid}/groups/{gid}/recipients/{id}
     - add Recipient to Group
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter id: (path) the id of the recipient 

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func addRecipientToGroupWithRequestBuilder(lid lid: String, gid: String, id: String) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/groups/{gid}/recipients/{id}"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{gid}", withString: "\(gid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     add all Recipients to the given group
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func addRecipientsToGroup(lid lid: String, gid: String, filter: String? = nil, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        addRecipientsToGroupWithRequestBuilder(lid: lid, gid: gid, filter: filter).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     add all Recipients to the given group
     - POST /lists/{lid}/groups/{gid}/recipients
     - add all Recipients to the given group. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting added to the group!
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter filter: (query) a FIQL-Filter (optional)

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func addRecipientsToGroupWithRequestBuilder(lid lid: String, gid: String, filter: String? = nil) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/groups/{gid}/recipients"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{gid}", withString: "\(gid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     creates a new group
     
     - parameter group: (body) the data to save 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func createGroup(group group: GroupPost, completion: ((data: ApiResponsePost?, error: ErrorType?) -> Void)) {
        createGroupWithRequestBuilder(group: group).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     creates a new group
     - POST /groups
     - creates a new group.
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "id" : "aeiou"
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter group: (body) the data to save 

     - returns: RequestBuilder<ApiResponsePost> 
     */
    public class func createGroupWithRequestBuilder(group group: GroupPost) -> RequestBuilder<ApiResponsePost> {
        let path = "/groups"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = group.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ApiResponsePost>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     delete the Group
     
     - parameter id: (path) the id of the Group 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func deleteGroup(id id: String, completion: ((data: ApiResponseDelete?, error: ErrorType?) -> Void)) {
        deleteGroupWithRequestBuilder(id: id).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     delete the Group
     - DELETE /groups/{id}
     - delete one Group
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={ }}]
     
     - parameter id: (path) the id of the Group 

     - returns: RequestBuilder<ApiResponseDelete> 
     */
    public class func deleteGroupWithRequestBuilder(id id: String) -> RequestBuilder<ApiResponseDelete> {
        var path = "/groups/{id}"
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ApiResponseDelete>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     get all Group of selected list
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getGroups(lid lid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil, completion: ((data: GroupResponse?, error: ErrorType?) -> Void)) {
        getGroupsWithRequestBuilder(lid: lid, filter: filter, limit: limit, offset: offset, expand: expand, fields: fields).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get all Group of selected list
     - GET /lists/{lid}/groups
     - get Groups
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "list_id" : "aeiou",
    "name" : "aeiou",
    "description" : "aeiou",
    "id" : "aeiou"
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

     - returns: RequestBuilder<GroupResponse> 
     */
    public class func getGroupsWithRequestBuilder(lid lid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil) -> RequestBuilder<GroupResponse> {
        var path = "/lists/{lid}/groups"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter,
            "_limit": limit?.encodeToJSON(),
            "_offset": offset?.encodeToJSON(),
            "_expand": expand,
            "_fields": fields
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<GroupResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     get all Recipients of selected group
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getRecipientsByGroup(lid lid: String, gid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil, completion: ((data: RecipientResponse?, error: ErrorType?) -> Void)) {
        getRecipientsByGroupWithRequestBuilder(lid: lid, gid: gid, filter: filter, limit: limit, offset: offset, expand: expand, fields: fields).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get all Recipients of selected group
     - GET /lists/{lid}/groups/{gid}/recipients
     - get Recipients
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "statistic_last_mail_converted" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_useragent_device" : "aeiou",
    "gender" : "aeiou",
    "statistic_last_unsubscribe_list" : "2000-01-23T04:56:07.000+0000",
    "rating" : "",
    "statistic_mails_clicked" : "",
    "statistic_last_longitude" : 1.3579000000000001069366817318950779736042022705078125,
    "statistic_mails_opened" : "",
    "statistic_last_blacklist_list_reason" : "aeiou",
    "id" : "aeiou",
    "first_name" : "aeiou",
    "email" : "aeiou",
    "_custom_attribute_" : "aeiou",
    "statistic_last_useragent_family" : "aeiou",
    "statistic_last_blacklist_list" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_mail_received" : "2000-01-23T04:56:07.000+0000",
    "statistic_conversions_sum" : 1.3579000000000001069366817318950779736042022705078125,
    "is_unsubscribed" : true,
    "statistic_last_mail_action" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_unsubscribe_list_reason" : "aeiou",
    "last_name" : "aeiou",
    "is_blacklisted" : true,
    "statistic_conversions" : "",
    "statistic_last_mail_clicked" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_latitude" : 1.3579000000000001069366817318950779736042022705078125,
    "phone" : "aeiou",
    "statistic_last_mail_opened" : "2000-01-23T04:56:07.000+0000",
    "statistic_mails_received" : "",
    "statistic_mails_unique_opened" : ""
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

     - returns: RequestBuilder<RecipientResponse> 
     */
    public class func getRecipientsByGroupWithRequestBuilder(lid lid: String, gid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil) -> RequestBuilder<RecipientResponse> {
        var path = "/lists/{lid}/groups/{gid}/recipients"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{gid}", withString: "\(gid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter,
            "_limit": limit?.encodeToJSON(),
            "_offset": offset?.encodeToJSON(),
            "_expand": expand,
            "_fields": fields
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<RecipientResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     remove single recipient from group
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter id: (path) the id of the recipient 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func removeRecipientFromGroup(lid lid: String, gid: String, id: String, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        removeRecipientFromGroupWithRequestBuilder(lid: lid, gid: gid, id: id).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     remove single recipient from group
     - DELETE /lists/{lid}/groups/{gid}/recipients/{id}
     - remove Recipient to Group
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter id: (path) the id of the recipient 

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func removeRecipientFromGroupWithRequestBuilder(lid lid: String, gid: String, id: String) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/groups/{gid}/recipients/{id}"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{gid}", withString: "\(gid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     remove all Recipients from given group
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func removeRecipientsFromGroup(lid lid: String, gid: String, filter: String? = nil, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        removeRecipientsFromGroupWithRequestBuilder(lid: lid, gid: gid, filter: filter).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     remove all Recipients from given group
     - DELETE /lists/{lid}/groups/{gid}/recipients
     - remove all Recipients from given group. Pay attention to the filter, if you forget to submit it, all recipients are getting removed from the group!
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter filter: (query) a FIQL-Filter (optional)

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func removeRecipientsFromGroupWithRequestBuilder(lid lid: String, gid: String, filter: String? = nil) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/groups/{gid}/recipients"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{gid}", withString: "\(gid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     update the Group
     
     - parameter id: (path) the id of the Group 
     - parameter group: (body) the data to update 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func updateGroup(id id: String, group: GroupPatch, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        updateGroupWithRequestBuilder(id: id, group: group).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     update the Group
     - PATCH /groups/{id}
     - update one Group
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter id: (path) the id of the Group 
     - parameter group: (body) the data to update 

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func updateGroupWithRequestBuilder(id id: String, group: GroupPatch) -> RequestBuilder<PatchResponse> {
        var path = "/groups/{id}"
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = group.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PATCH", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

}
