//
// NewsletterAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class NewsletterAPI: APIBase {
    /**
     creates a new newsletter
     
     - parameter lid: (path) the id of the list 
     - parameter newsletter: (body) the data to save 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func createNewsletter(lid lid: String, newsletter: NewsletterPost, completion: ((data: ApiResponsePost?, error: ErrorType?) -> Void)) {
        createNewsletterWithRequestBuilder(lid: lid, newsletter: newsletter).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     creates a new newsletter
     - POST /lists/{lid}/newsletters
     - creates a new Newsletter
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "id" : "aeiou"
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter newsletter: (body) the data to save 

     - returns: RequestBuilder<ApiResponsePost> 
     */
    public class func createNewsletterWithRequestBuilder(lid lid: String, newsletter: NewsletterPost) -> RequestBuilder<ApiResponsePost> {
        var path = "/lists/{lid}/newsletters"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = newsletter.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ApiResponsePost>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     get one newsletter
     
     - parameter id: (path) the id of the newsletter 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getNewsletter(id id: String, filter: String? = nil, fields: [String]? = nil, completion: ((data: NewsletterResponse?, error: ErrorType?) -> Void)) {
        getNewsletterWithRequestBuilder(id: id, filter: filter, fields: fields).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get one newsletter
     - GET /newsletters/{id}
     - get Newsletter
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "has_open_tracking" : true,
    "has_conversion_tracking" : true,
    "list_id" : "aeiou",
    "name" : "aeiou",
    "description" : "aeiou",
    "id" : "aeiou",
    "type" : "aeiou",
    "has_click_tracking" : true
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter id: (path) the id of the newsletter 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

     - returns: RequestBuilder<NewsletterResponse> 
     */
    public class func getNewsletterWithRequestBuilder(id id: String, filter: String? = nil, fields: [String]? = nil) -> RequestBuilder<NewsletterResponse> {
        var path = "/newsletters/{id}"
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter,
            "_fields": fields
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<NewsletterResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     get all newsletters of the given list
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getNewsletters(lid lid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil, completion: ((data: NewsletterResponse?, error: ErrorType?) -> Void)) {
        getNewslettersWithRequestBuilder(lid: lid, filter: filter, limit: limit, offset: offset, expand: expand, fields: fields).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get all newsletters of the given list
     - GET /lists/{lid}/newsletters
     - get Newsletters
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "has_open_tracking" : true,
    "has_conversion_tracking" : true,
    "list_id" : "aeiou",
    "name" : "aeiou",
    "description" : "aeiou",
    "id" : "aeiou",
    "type" : "aeiou",
    "has_click_tracking" : true
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

     - returns: RequestBuilder<NewsletterResponse> 
     */
    public class func getNewslettersWithRequestBuilder(lid lid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil) -> RequestBuilder<NewsletterResponse> {
        var path = "/lists/{lid}/newsletters"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter,
            "_limit": limit?.encodeToJSON(),
            "_offset": offset?.encodeToJSON(),
            "_expand": expand,
            "_fields": fields
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<NewsletterResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     get reports for the newsletter aggregated by days
     
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getReports(filter filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil, completion: ((data: ReportResponse?, error: ErrorType?) -> Void)) {
        getReportsWithRequestBuilder(filter: filter, limit: limit, offset: offset, expand: expand, fields: fields).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get reports for the newsletter aggregated by days
     - GET /lists/{lid}/newsletters/{nid}/aggregations
     - get reports for the newsletter aggregated by days
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "date" : "2000-01-23T04:56:07.000+0000",
    "conversions" : "",
    "unsubscribes" : "",
    "spam_bounces" : "",
    "sum_conversions" : "",
    "soft_bounces" : "",
    "newsletter_id" : "aeiou",
    "unique_opens" : "",
    "mail_count" : "",
    "hard_bounces" : "",
    "unique_clicks" : "",
    "opens" : "",
    "clicks" : ""
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

     - returns: RequestBuilder<ReportResponse> 
     */
    public class func getReportsWithRequestBuilder(filter filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil) -> RequestBuilder<ReportResponse> {
        let path = "/lists/{lid}/newsletters/{nid}/aggregations"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter,
            "_limit": limit?.encodeToJSON(),
            "_offset": offset?.encodeToJSON(),
            "_expand": expand,
            "_fields": fields
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ReportResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Sends the newsletter to a list or group
     
     - parameter id: (path) the id of the list 
     - parameter newsletter: (body) the data to save 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func sendNewsletter(id id: String, newsletter: NewsletterSend, completion: ((error: ErrorType?) -> Void)) {
        sendNewsletterWithRequestBuilder(id: id, newsletter: newsletter).execute { (response, error) -> Void in
            completion(error: error);
        }
    }


    /**
     Sends the newsletter to a list or group
     - POST /newsletters/{id}/send
     - 
     - OAuth:
       - type: oauth2
       - name: OAuth
     
     - parameter id: (path) the id of the list 
     - parameter newsletter: (body) the data to save 

     - returns: RequestBuilder<Void> 
     */
    public class func sendNewsletterWithRequestBuilder(id id: String, newsletter: NewsletterSend) -> RequestBuilder<Void> {
        var path = "/newsletters/{id}/send"
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = newsletter.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     update the Newsletter
     
     - parameter id: (path) the id of the newsletter 
     - parameter newsletter: (body) the data to update 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func updateNewsletter(id id: String, newsletter: NewsletterPost, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        updateNewsletterWithRequestBuilder(id: id, newsletter: newsletter).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     update the Newsletter
     - PATCH /newsletters/{id}
     - update one Newsletter
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter id: (path) the id of the newsletter 
     - parameter newsletter: (body) the data to update 

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func updateNewsletterWithRequestBuilder(id id: String, newsletter: NewsletterPost) -> RequestBuilder<PatchResponse> {
        var path = "/newsletters/{id}"
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = newsletter.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PATCH", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

}
