//
// RecipientAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class RecipientAPI: APIBase {
    /**
     add single recipient to group
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter id: (path) the id of the recipient 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func addRecipientToGroup(lid lid: String, gid: String, id: String, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        addRecipientToGroupWithRequestBuilder(lid: lid, gid: gid, id: id).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     add single recipient to group
     - POST /lists/{lid}/groups/{gid}/recipients/{id}
     - add Recipient to Group
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter id: (path) the id of the recipient 

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func addRecipientToGroupWithRequestBuilder(lid lid: String, gid: String, id: String) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/groups/{gid}/recipients/{id}"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{gid}", withString: "\(gid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     add all Recipients to the given group
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func addRecipientsToGroup(lid lid: String, gid: String, filter: String? = nil, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        addRecipientsToGroupWithRequestBuilder(lid: lid, gid: gid, filter: filter).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     add all Recipients to the given group
     - POST /lists/{lid}/groups/{gid}/recipients
     - add all Recipients to the given group. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting added to the group!
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter filter: (query) a FIQL-Filter (optional)

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func addRecipientsToGroupWithRequestBuilder(lid lid: String, gid: String, filter: String? = nil) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/groups/{gid}/recipients"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{gid}", withString: "\(gid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     create new recipient(s) or updates existing ones
     
     - parameter recipient: (body) the data to save 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func createRecipient(recipient recipient: RecipientPost, completion: ((data: ApiResponsePost?, error: ErrorType?) -> Void)) {
        createRecipientWithRequestBuilder(recipient: recipient).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     create new recipient(s) or updates existing ones
     - POST /recipients
     - create new recipient(s).<br>If a custom attribute shall by saved for the new recipient just submit them in the json body by name.<br>If <b>multiple recipients</b> shall by saved at once, submit multiple recipient-objects as a json array.<br><b>In this case all objects must share the same attributes.</b><br/>If the e-mail-address exists already the existing recipient gets updated.
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "id" : "aeiou"
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter recipient: (body) the data to save 

     - returns: RequestBuilder<ApiResponsePost> 
     */
    public class func createRecipientWithRequestBuilder(recipient recipient: RecipientPost) -> RequestBuilder<ApiResponsePost> {
        let path = "/recipients"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = recipient.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ApiResponsePost>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     delete the recipient
     
     - parameter lid: (path) the id of the list 
     - parameter id: (path) the id of the recipient 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func deleteRecipient(lid lid: String, id: String, completion: ((data: ApiResponseDelete?, error: ErrorType?) -> Void)) {
        deleteRecipientWithRequestBuilder(lid: lid, id: id).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     delete the recipient
     - DELETE /lists/{lid}/recipients/{id}
     - delete one recipient
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={ }}]
     
     - parameter lid: (path) the id of the list 
     - parameter id: (path) the id of the recipient 

     - returns: RequestBuilder<ApiResponseDelete> 
     */
    public class func deleteRecipientWithRequestBuilder(lid lid: String, id: String) -> RequestBuilder<ApiResponseDelete> {
        var path = "/lists/{lid}/recipients/{id}"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ApiResponseDelete>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     get all Recipients of selected list
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getRecipients(lid lid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil, completion: ((data: RecipientResponse?, error: ErrorType?) -> Void)) {
        getRecipientsWithRequestBuilder(lid: lid, filter: filter, limit: limit, offset: offset, expand: expand, fields: fields).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get all Recipients of selected list
     - GET /lists/{lid}/recipients
     - Get Recipients. If the API shall return custom attributes also, submit them in the _fields-Parameter by name.
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "statistic_last_mail_converted" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_useragent_device" : "aeiou",
    "gender" : "aeiou",
    "statistic_last_unsubscribe_list" : "2000-01-23T04:56:07.000+0000",
    "rating" : "",
    "statistic_mails_clicked" : "",
    "statistic_last_longitude" : 1.3579000000000001069366817318950779736042022705078125,
    "statistic_mails_opened" : "",
    "statistic_last_blacklist_list_reason" : "aeiou",
    "id" : "aeiou",
    "first_name" : "aeiou",
    "email" : "aeiou",
    "_custom_attribute_" : "aeiou",
    "statistic_last_useragent_family" : "aeiou",
    "statistic_last_blacklist_list" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_mail_received" : "2000-01-23T04:56:07.000+0000",
    "statistic_conversions_sum" : 1.3579000000000001069366817318950779736042022705078125,
    "is_unsubscribed" : true,
    "statistic_last_mail_action" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_unsubscribe_list_reason" : "aeiou",
    "last_name" : "aeiou",
    "is_blacklisted" : true,
    "statistic_conversions" : "",
    "statistic_last_mail_clicked" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_latitude" : 1.3579000000000001069366817318950779736042022705078125,
    "phone" : "aeiou",
    "statistic_last_mail_opened" : "2000-01-23T04:56:07.000+0000",
    "statistic_mails_received" : "",
    "statistic_mails_unique_opened" : ""
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

     - returns: RequestBuilder<RecipientResponse> 
     */
    public class func getRecipientsWithRequestBuilder(lid lid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil) -> RequestBuilder<RecipientResponse> {
        var path = "/lists/{lid}/recipients"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter,
            "_limit": limit?.encodeToJSON(),
            "_offset": offset?.encodeToJSON(),
            "_expand": expand,
            "_fields": fields
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<RecipientResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     get all Recipients of selected group
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getRecipientsByGroup(lid lid: String, gid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil, completion: ((data: RecipientResponse?, error: ErrorType?) -> Void)) {
        getRecipientsByGroupWithRequestBuilder(lid: lid, gid: gid, filter: filter, limit: limit, offset: offset, expand: expand, fields: fields).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get all Recipients of selected group
     - GET /lists/{lid}/groups/{gid}/recipients
     - get Recipients
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "statistic_last_mail_converted" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_useragent_device" : "aeiou",
    "gender" : "aeiou",
    "statistic_last_unsubscribe_list" : "2000-01-23T04:56:07.000+0000",
    "rating" : "",
    "statistic_mails_clicked" : "",
    "statistic_last_longitude" : 1.3579000000000001069366817318950779736042022705078125,
    "statistic_mails_opened" : "",
    "statistic_last_blacklist_list_reason" : "aeiou",
    "id" : "aeiou",
    "first_name" : "aeiou",
    "email" : "aeiou",
    "_custom_attribute_" : "aeiou",
    "statistic_last_useragent_family" : "aeiou",
    "statistic_last_blacklist_list" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_mail_received" : "2000-01-23T04:56:07.000+0000",
    "statistic_conversions_sum" : 1.3579000000000001069366817318950779736042022705078125,
    "is_unsubscribed" : true,
    "statistic_last_mail_action" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_unsubscribe_list_reason" : "aeiou",
    "last_name" : "aeiou",
    "is_blacklisted" : true,
    "statistic_conversions" : "",
    "statistic_last_mail_clicked" : "2000-01-23T04:56:07.000+0000",
    "statistic_last_latitude" : 1.3579000000000001069366817318950779736042022705078125,
    "phone" : "aeiou",
    "statistic_last_mail_opened" : "2000-01-23T04:56:07.000+0000",
    "statistic_mails_received" : "",
    "statistic_mails_unique_opened" : ""
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

     - returns: RequestBuilder<RecipientResponse> 
     */
    public class func getRecipientsByGroupWithRequestBuilder(lid lid: String, gid: String, filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil) -> RequestBuilder<RecipientResponse> {
        var path = "/lists/{lid}/groups/{gid}/recipients"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{gid}", withString: "\(gid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter,
            "_limit": limit?.encodeToJSON(),
            "_offset": offset?.encodeToJSON(),
            "_expand": expand,
            "_fields": fields
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<RecipientResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Initialize the import of recipients by file
     
     - parameter lid: (path) the id of the list 
     - parameter file: (form) recipient file to upload 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func importRecipientsInit(lid lid: String, file: NSURL, completion: ((data: InlineResponse200?, error: ErrorType?) -> Void)) {
        importRecipientsInitWithRequestBuilder(lid: lid, file: file).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Initialize the import of recipients by file
     - POST /lists/{lid}/recipients/import/init
     - Initialize the import recipients by file
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "file" : "aeiou",
  "success" : true
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter file: (form) recipient file to upload 

     - returns: RequestBuilder<InlineResponse200> 
     */
    public class func importRecipientsInitWithRequestBuilder(lid lid: String, file: NSURL) -> RequestBuilder<InlineResponse200> {
        var path = "/lists/{lid}/recipients/import/init"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "file": file
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<InlineResponse200>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Start the import recipients by file
     
     - parameter lid: (path) the id of the list 
     - parameter data: (body) the data to start the import 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func importRecipientsSave(lid lid: String, data: Data, completion: ((data: ApiResponsePost?, error: ErrorType?) -> Void)) {
        importRecipientsSaveWithRequestBuilder(lid: lid, data: data).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Start the import recipients by file
     - POST /lists/{lid}/recipients/import/save
     - Start the import recipients by file. The returned id can be used to fetch further statistics about the import.
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "id" : "aeiou"
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter data: (body) the data to start the import 

     - returns: RequestBuilder<ApiResponsePost> 
     */
    public class func importRecipientsSaveWithRequestBuilder(lid lid: String, data: Data) -> RequestBuilder<ApiResponsePost> {
        var path = "/lists/{lid}/recipients/import/save"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = data.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ApiResponsePost>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     Get statistics about the import by file
     
     - parameter id: (path) the id of the import job 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func importRecipientsStatistics(id id: String, completion: ((data: ImportResponse?, error: ErrorType?) -> Void)) {
        importRecipientsStatisticsWithRequestBuilder(id: id).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Get statistics about the import by file
     - GET /import/{id}/info
     - Get statistics about the import by file.
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "invalid_recipients" : [ "" ],
    "count_updated" : "",
    "duplicate_recipients" : [ {
      "last_name" : "aeiou",
      "first_name" : "aeiou",
      "email" : "aeiou"
    } ],
    "count_inserted" : "",
    "count_failed" : ""
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter id: (path) the id of the import job 

     - returns: RequestBuilder<ImportResponse> 
     */
    public class func importRecipientsStatisticsWithRequestBuilder(id id: String) -> RequestBuilder<ImportResponse> {
        var path = "/import/{id}/info"
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ImportResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     remove single recipient from group
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter id: (path) the id of the recipient 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func removeRecipientFromGroup(lid lid: String, gid: String, id: String, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        removeRecipientFromGroupWithRequestBuilder(lid: lid, gid: gid, id: id).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     remove single recipient from group
     - DELETE /lists/{lid}/groups/{gid}/recipients/{id}
     - remove Recipient to Group
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter id: (path) the id of the recipient 

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func removeRecipientFromGroupWithRequestBuilder(lid lid: String, gid: String, id: String) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/groups/{gid}/recipients/{id}"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{gid}", withString: "\(gid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [:]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     remove all Recipients from given group
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func removeRecipientsFromGroup(lid lid: String, gid: String, filter: String? = nil, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        removeRecipientsFromGroupWithRequestBuilder(lid: lid, gid: gid, filter: filter).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     remove all Recipients from given group
     - DELETE /lists/{lid}/groups/{gid}/recipients
     - remove all Recipients from given group. Pay attention to the filter, if you forget to submit it, all recipients are getting removed from the group!
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter gid: (path) the id of the group 
     - parameter filter: (query) a FIQL-Filter (optional)

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func removeRecipientsFromGroupWithRequestBuilder(lid lid: String, gid: String, filter: String? = nil) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/groups/{gid}/recipients"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{gid}", withString: "\(gid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     remove all Recipients from selected list
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func removeRecipientsFromList(lid lid: String, filter: String? = nil, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        removeRecipientsFromListWithRequestBuilder(lid: lid, filter: filter).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     remove all Recipients from selected list
     - DELETE /lists/{lid}/recipients
     - remove Recipients from selected list. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting removed!
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func removeRecipientsFromListWithRequestBuilder(lid lid: String, filter: String? = nil) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/recipients"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Creates a new recipient and sends a DOI-Mail
     
     - parameter code: (path) the subscribe-code displayed when creating a subscribe-form 
     - parameter recipient: (body) the recipient to subscribe 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func subscribeRecipient(code code: String, recipient: RecipientSubscribe, completion: ((data: RecipientSubscribeResponse?, error: ErrorType?) -> Void)) {
        subscribeRecipientWithRequestBuilder(code: code, recipient: recipient).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Creates a new recipient and sends a DOI-Mail
     - POST /forms/submit/{code}
     - Creates a new recipient and sends the corresponding DOI-Mail attached to the previously created subscribe-form. The recipient will be available as soon as the recipient has confirmed the DOI-Mail.
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "result" : {
      "success" : {
        "inserted" : ""
      },
      "error" : {
        "recipients" : {
          "invalid" : [ "" ],
          "duplicate" : [ {
            "last_name" : "aeiou",
            "first_name" : "aeiou",
            "email" : "aeiou"
          } ]
        },
        "failed" : ""
      }
    }
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter code: (path) the subscribe-code displayed when creating a subscribe-form 
     - parameter recipient: (body) the recipient to subscribe 

     - returns: RequestBuilder<RecipientSubscribeResponse> 
     */
    public class func subscribeRecipientWithRequestBuilder(code code: String, recipient: RecipientSubscribe) -> RequestBuilder<RecipientSubscribeResponse> {
        var path = "/forms/submit/{code}"
        path = path.stringByReplacingOccurrencesOfString("{code}", withString: "\(code)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = recipient.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<RecipientSubscribeResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     update the recipient.
     
     - parameter lid: (path) the id of the list 
     - parameter id: (path) the id of the recipient 
     - parameter recipient: (body) the data to update 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func updateRecipient(lid lid: String, id: String, recipient: RecipientPatch, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        updateRecipientWithRequestBuilder(lid: lid, id: id, recipient: recipient).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     update the recipient.
     - PATCH /lists/{lid}/recipients/{id}
     - update one Recipient. If a value of a custom attribute shall by changed just submit it in the json body
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter id: (path) the id of the recipient 
     - parameter recipient: (body) the data to update 

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func updateRecipientWithRequestBuilder(lid lid: String, id: String, recipient: RecipientPatch) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/recipients/{id}"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        path = path.stringByReplacingOccurrencesOfString("{id}", withString: "\(id)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = recipient.encodeToJSON() as? [String:AnyObject]
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PATCH", URLString: URLString, parameters: convertedParameters, isBody: true)
    }

    /**
     update all Recipients in selected list
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func updateRecipients(lid lid: String, filter: String? = nil, completion: ((data: PatchResponse?, error: ErrorType?) -> Void)) {
        updateRecipientsWithRequestBuilder(lid: lid, filter: filter).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     update all Recipients in selected list
     - PATCH /lists/{lid}/recipients
     - Updates all recipients in the given list where the filter applies. If a value of a custom attribute shall by changed just submit it in the json body. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting updated!
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter lid: (path) the id of the list 
     - parameter filter: (query) a FIQL-Filter (optional)

     - returns: RequestBuilder<PatchResponse> 
     */
    public class func updateRecipientsWithRequestBuilder(lid lid: String, filter: String? = nil) -> RequestBuilder<PatchResponse> {
        var path = "/lists/{lid}/recipients"
        path = path.stringByReplacingOccurrencesOfString("{lid}", withString: "\(lid)", options: .LiteralSearch, range: nil)
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<PatchResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PATCH", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

}
