//
// ReportAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class ReportAPI: APIBase {
    /**
     get reports for the newsletter aggregated by days
     
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func getReports(filter filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil, completion: ((data: ReportResponse?, error: ErrorType?) -> Void)) {
        getReportsWithRequestBuilder(filter: filter, limit: limit, offset: offset, expand: expand, fields: fields).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     get reports for the newsletter aggregated by days
     - GET /lists/{lid}/newsletters/{nid}/aggregations
     - get reports for the newsletter aggregated by days
     - OAuth:
       - type: oauth2
       - name: OAuth
     - examples: [{contentType=application/json, example={
  "value" : [ {
    "date" : "2000-01-23T04:56:07.000+0000",
    "conversions" : "",
    "unsubscribes" : "",
    "spam_bounces" : "",
    "sum_conversions" : "",
    "soft_bounces" : "",
    "newsletter_id" : "aeiou",
    "unique_opens" : "",
    "mail_count" : "",
    "hard_bounces" : "",
    "unique_clicks" : "",
    "opens" : "",
    "clicks" : ""
  } ],
  "info" : {
    "count" : ""
  }
}}]
     
     - parameter filter: (query) a FIQL-Filter (optional)
     - parameter limit: (query) a limit for list-responses (optional, default to 50)
     - parameter offset: (query) an offset for list-responses (optional, default to 0)
     - parameter expand: (query) true if attributes should be returned or not (optional)
     - parameter fields: (query) list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

     - returns: RequestBuilder<ReportResponse> 
     */
    public class func getReportsWithRequestBuilder(filter filter: String? = nil, limit: Int32? = nil, offset: Int32? = nil, expand: Bool? = nil, fields: [String]? = nil) -> RequestBuilder<ReportResponse> {
        let path = "/lists/{lid}/newsletters/{nid}/aggregations"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_filter": filter,
            "_limit": limit?.encodeToJSON(),
            "_offset": offset?.encodeToJSON(),
            "_expand": expand,
            "_fields": fields
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<ReportResponse>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

}
