//
// RecipientGet.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation


public class RecipientGet: JSONEncodable {
    public enum Gender: String { 
        case M = "m"
        case F = "f"
    }
    public enum StatisticLastUseragentDevice: String { 
        case Desktop = "desktop"
        case Mobile = "mobile"
        case Tablet = "tablet"
    }
    public enum StatisticLastUseragentFamily: String { 
        case LotusNotes = "lotus_notes"
        case AppleMail = "apple_mail"
        case Thunderbird = "thunderbird"
        case WindowsLiveMail = "windows_live_mail"
        case Outlook = "outlook"
        case Ios = "iOS"
        case Android = "Android"
        case Windows = "Windows"
        case Else = "else"
    }
    /** the id of the recipient */
    public var id: String?
    /** the email of the recipient */
    public var email: String?
    /** the phone number of the recipient */
    public var phone: String?
    /** m for male and f for female */
    public var gender: Gender?
    /** the first name of the recipient */
    public var firstName: String?
    /** the last name of the recipient */
    public var lastName: String?
    /** weither the recipient is unsubscribed or not */
    public var isUnsubscribed: Bool?
    /** weither the recipient is blacklisted or not */
    public var isBlacklisted: Bool?
    /** every custom attribute can be submitted */
    public var customAttribute_: String?
    /** Indicating the quality of the recipient. Between 0 and 5 */
    public var rating: Int32?
    /** how many newsletters the recipient has received */
    public var statisticMailsReceived: Int32?
    /** how many newsletters the recipient has opened */
    public var statisticMailsOpened: Int32?
    /** how many newsletters the recipient has uniqly opened */
    public var statisticMailsUniqueOpened: Int32?
    /** how often the recipient has clicked on links in newsletters */
    public var statisticMailsClicked: Int32?
    /** how often the recipient has converted */
    public var statisticConversions: Int32?
    /** how much the recipient has spent */
    public var statisticConversionsSum: Float?
    /** when the recipient has had the last interaction with a newsletter */
    public var statisticLastMailAction: NSDate?
    /** when the recipient has had received the last newsletter */
    public var statisticLastMailReceived: NSDate?
    /** when the recipient has had opened the last newsletter */
    public var statisticLastMailOpened: NSDate?
    /** when the recipient has had clicked the last newsletter */
    public var statisticLastMailClicked: NSDate?
    /** when the recipient has had converted the last time */
    public var statisticLastMailConverted: NSDate?
    /** the last useragent device used for opening a newsletter */
    public var statisticLastUseragentDevice: StatisticLastUseragentDevice?
    /** the last useragent family used for opening a newsletter */
    public var statisticLastUseragentFamily: StatisticLastUseragentFamily?
    /** the last latitude where the recipient has opened a newsletter */
    public var statisticLastLatitude: Double?
    /** the last longitude where the recipient has opened a newsletter */
    public var statisticLastLongitude: Double?
    /** when the recipient was blacklisted the last time */
    public var statisticLastBlacklistList: NSDate?
    /** when the recipient was unsubscribed the last time */
    public var statisticLastUnsubscribeList: NSDate?
    /** the reason the recipient got blacklisted the last time */
    public var statisticLastBlacklistListReason: String?
    /** the reason the recipient got unsubscribed the last time */
    public var statisticLastUnsubscribeListReason: String?

    public init() {}

    // MARK: JSONEncodable
    func encodeToJSON() -> AnyObject {
        var nillableDictionary = [String:AnyObject?]()
        nillableDictionary["id"] = self.id
        nillableDictionary["email"] = self.email
        nillableDictionary["phone"] = self.phone
        nillableDictionary["gender"] = self.gender?.rawValue
        nillableDictionary["first_name"] = self.firstName
        nillableDictionary["last_name"] = self.lastName
        nillableDictionary["is_unsubscribed"] = self.isUnsubscribed
        nillableDictionary["is_blacklisted"] = self.isBlacklisted
        nillableDictionary["_custom_attribute_"] = self.customAttribute_
        nillableDictionary["rating"] = self.rating?.encodeToJSON()
        nillableDictionary["statistic_mails_received"] = self.statisticMailsReceived?.encodeToJSON()
        nillableDictionary["statistic_mails_opened"] = self.statisticMailsOpened?.encodeToJSON()
        nillableDictionary["statistic_mails_unique_opened"] = self.statisticMailsUniqueOpened?.encodeToJSON()
        nillableDictionary["statistic_mails_clicked"] = self.statisticMailsClicked?.encodeToJSON()
        nillableDictionary["statistic_conversions"] = self.statisticConversions?.encodeToJSON()
        nillableDictionary["statistic_conversions_sum"] = self.statisticConversionsSum
        nillableDictionary["statistic_last_mail_action"] = self.statisticLastMailAction?.encodeToJSON()
        nillableDictionary["statistic_last_mail_received"] = self.statisticLastMailReceived?.encodeToJSON()
        nillableDictionary["statistic_last_mail_opened"] = self.statisticLastMailOpened?.encodeToJSON()
        nillableDictionary["statistic_last_mail_clicked"] = self.statisticLastMailClicked?.encodeToJSON()
        nillableDictionary["statistic_last_mail_converted"] = self.statisticLastMailConverted?.encodeToJSON()
        nillableDictionary["statistic_last_useragent_device"] = self.statisticLastUseragentDevice?.rawValue
        nillableDictionary["statistic_last_useragent_family"] = self.statisticLastUseragentFamily?.rawValue
        nillableDictionary["statistic_last_latitude"] = self.statisticLastLatitude
        nillableDictionary["statistic_last_longitude"] = self.statisticLastLongitude
        nillableDictionary["statistic_last_blacklist_list"] = self.statisticLastBlacklistList?.encodeToJSON()
        nillableDictionary["statistic_last_unsubscribe_list"] = self.statisticLastUnsubscribeList?.encodeToJSON()
        nillableDictionary["statistic_last_blacklist_list_reason"] = self.statisticLastBlacklistListReason
        nillableDictionary["statistic_last_unsubscribe_list_reason"] = self.statisticLastUnsubscribeListReason
        let dictionary: [String:AnyObject] = APIHelper.rejectNil(nillableDictionary) ?? [:]
        return dictionary
    }
}
